#if defined _events_included
  #endinput
#endif
#define _events_included

#define MAX_EVENTS 23
#define ACCESS_CONSOLE 131072

enum event {
    player_join_game = 0,      // Data[0] = Userindex
    player_join_team,          // Data[0] = Userindex, Data[1] = Team (0 = Spec, 1 = T, 2 = CT)
    world_game_commencing,     // No Data
    world_game_restart,        // No Data
    world_round_start,         // No Data
    world_round_end,           // No Data
    world_round_draw,          // Data[0] = 2-byte encoded T-score, Data[2] = 2-byte encoded CT score
    world_round_win,           // Data[0] = winning team, Data[1] 2-byte encoded T score, Data[3] 2-byte encoded CT score, Data[5] = Action (e.g. Target_Saved, Terrorists_Win)
    player_injure,             // Data[0] = attacker, Data[1] = victim, Data[2] = 2-byte encoded health-damage, Data[4] = 2-byte encoded armor-damage, Data[6] = weapon
    player_kill,               // Data[0] = Attacker, Data[1] = Victim, Data[2] = weapon
    player_suicide,            // Data[0] = victim, Data[1] = weapon (e.g. hegrenade, world)
    player_bomb_spawn,         // Data[0] = userindex
    player_bomb_pickup,        // Data[0] = userindex
    player_bomb_drop,          // Data[0] = userindex
    player_bomb_plant,         // Data[0] = userindex
    player_bomb_begindefuse,   // Data[0] = userindex, Data[1] = defusekit
    player_bomb_defuse,        // Data[0] = userindex
    player_hostage_touch,      // Data[0] = userindex
    player_hostage_kill,       // Data[0] = userindex
    player_hostage_rescue,     // Data[0] = userindex
    player_vip_spawn,          // Data[0] = userindex
    player_vip_kill,           // Data[0] = userindex
    player_vip_escape          // Data[0] = userindex
};

forward register_logd_event(event:Event,Function[]);

stock const g_Function[MAX_EVENTS][] = {
    "be_reg_joingame",
    "be_reg_jointeam",
    "be_reg_commencing",
    "be_reg_restart",
    "be_reg_roundstart",
    "be_reg_rounddraw",
    "be_reg_roundwin",
    "be_reg_roundend",
    "be_reg_injure",
    "be_reg_kill",
    "be_reg_suicide",
    "be_reg_bombspawn",
    "be_reg_bombpickup",
    "be_reg_bombdrop",
    "be_reg_bombplant",
    "be_reg_begindefuse",
    "be_reg_defuse",
    "be_reg_touchhostage",
    "be_reg_killhostage",
    "be_reg_rescue",
    "be_reg_becomevip",
    "be_reg_killvip",
    "be_reg_vipescape"
};

stock register_logd_event(event:Event,Function[]) {
    new Data[3];
    numtostr(Event,Data);
    plugin_registercmd(g_Function[Event],Function,ACCESS_CONSOLE,"");
    new LineData[3];
    new Line;
    while(readfile("addons/adminmod/config/logd_events.ini",LineData,++Line,3)) {
        if(!strcmp(Data,LineData)) return;
    }
    writefile("addons/adminmod/config/logd_events.ini",Data,-1);
}

stock decode_2byte(src[]) {
    return (src[0] & 127) | ((src[1] & 127)<<7);
}