/* numtoword function
   converts an integer number (e.g. 12) to
   a text (e.g. "twelve"). works for all
   numbers between 0 and 999,999,999,999,999
 */

#if defined _numtoword_included
  #endinput
#endif
#define _numtoword_included

static OnesLib[10][] = { "", "one ", "two ", "three ", "four ", "five ", "six ", "seven ", "eight ", "nine " };
static TensLib[10][] = {"", "ten ", "twenty ", "thirty ", "fourty ", "fifty ", "sixty ", "seventy ", "eighty ", "ninety " } ;
static TeensLib[10][] = {"", "eleven ", "twelve ", "thirteen ", "fourteen ", "fifteen ", "sixteen ", "seventeen ", "eighteen ", "nineteen " };
static HundredsLib[10][] = { "", "one hundred ", "two hundred ", "three hundred ", "four hundred ", "five hundred ", "six hundred ", "seven hundred ", "eight hundred ", "nine hundred " };
static GroupNamesLib[5][] = {"", "thousand ", "million ", "billion ", "trillion " };

static stock do_numtoword(iNum,str[],iLevel,iLength) {

   /* If there is more than one group of 3, then take care of the others first. */
   if(iNum >= 1000) do_numtoword(iNum / 1000,str,iLevel + 1,iLength);

   /* Grab the the first 3 digits only */
   iNum %= 1000;

   /* Isolate each digit */
   new _hundreds = iNum / 100;
   new _tens = (iNum / 10) % 10;
   new _ones = iNum % 10;

   /* Take care of the teen numbers */
   if(_tens == 1 && _ones != 0) {
      snprintf(str,iLength,"%s%s%s%s",str,HundredsLib[_hundreds],TeensLib[_ones],GroupNamesLib[iLevel]);
   } else {
      snprintf(str,iLength,"%s%s%s%s%s",str,HundredsLib[_hundreds], TensLib[_tens], OnesLib[_ones],GroupNamesLib[iLevel]);
   }

   if(iLevel==0) str[strlen(str)-1] = 0; /* Gets rid of the trailing space*/
   return 1;
}

stock numtoword(iNum,str[],iLength) {
   /* Empties the first char of the string */
   str[0] = 0;
   str[iLength-1] = 0;
   if(iNum == 0) {
      snprintf(str,iLength,"zero");
      return 1;
   }
   if(iNum < 0) {
      iNum *= -1;
      snprintf(str,iLength,"negative ");
   }

   return do_numtoword(iNum,str,0,iLength);
}