#if defined _vectors_included
  #endinput
#endif
#define _vectors_included

stock abs(num) { //Returns the positive value of num.
    if(num > 0) {
        return num;
    }
    return -num;
}

stock pow(num,exp) { //Returns the power of num with exp.
    new p = num;
    new i;
    if(exp < 0) {
        return -1;
    } else if(exp == 0) {
        return 1;
    } else {
        for(i=1;i<exp;i++) {
            p *= num;
        }
    }
    return p;
}

stock sumvec(vec1[3],vec2[3],vec0[3]) { //Puts the sum-vector of vec1 and vec2 in vec0.
    new i;
    for(i=0;i<3;i++) {
        vec0[i] = vec1[i] + vec2[i];
    }
}

stock midvec(vec1[3],vec2[3],vec0[3]) { //Puts the mid of vec1 and vec2 in vec0.
    new i;
    for(i=0;i<3;i++) {
        vec0[i] = (vec1[i] + vec2[i]) / 2;
    }
}

stock diffvec(vec1[3],vec2[3],vec0[3]) { //Puts the diffenrece-vector of vec1 and vec2 in vec0.
    new i;
    for(i=0;i<3;i++) {
        vec0[i] = vec1[i] - vec2[i];
    }
}

stock veclen(vec[3],factor=1) { //Returns the length of a vector, multiplied with factor.
    new i,j,k,l;
    for(i=0;i<3;i++){
        l = factor * abs(vec[i]);
        k = max(l,k);
        j += l * l;
    }
    i = j;
    while(j > k) {
        j = (j + k) / 2;
        k = i / j;
    }
    return j;
}

stock distance(Index1,Index2) {
    new User[2][MAX_NAME_LENGTH];
    new Vec[2][3];
    playerinfo(Index1,User[0],MAX_NAME_LENGTH);
    playerinfo(Index2,User[1],MAX_NAME_LENGTH);
    get_userorigin(User[0],Vec[0][0],Vec[0][1],Vec[0][2]);
    get_userorigin(User[1],Vec[1][0],Vec[1][1],Vec[1][2]);
    new i,j = 0,k = 0,l;
    for(i=0;i<3;i++) {
        if(Vec[0][i] > Vec[1][i]) {
            l = Vec[0][i] - Vec[1][i];
        } else {
            l = Vec[1][i] - Vec[0][i];
        }
        if(l > k) {
            k = l;
        }
        j += l * l;
    }
    i = j;
    while(j > k) {
        j = (j + k) / 2;
        k = i / j;
    }
    return j;
}

stock veccmp(vec1[3],vec2[3],accuracy=0) { //Compares the length of two vectors. Returns a value less than, equal to or greater zero if vec1 is found to be shorter than, to match, or be longer than vec2. A greater accuracy will result in a more accurate comparison.
    new m = pow(10,max(0,accuracy));
    return veclen(vec1,m) - veclen(vec2,m);
}

stock vecncmp(vec[3],num) { //Compares the length of the vector with the number. Returns a value less than, equal to or greater zero if vec is found to be shorter than, to match, or be longer than num. A greater accuracy will result in a more accurate comparison.
    return veclen(vec,1) - num;
}

stock vecstrcmp(vec[3],str[],accuracy=0) { //Compares the length of the vector with the float point number in str. Returns a value less than, equal to or greater zero if vec is found to be shorter than, to match, or be longer than the number. A greater accuracy will result in a more accurate comparison.
    new num,m = pow(10,strlen(str)-strchr(str,'.')-1+max(0,accuracy));
    strsubst(str,".","",strlen(str));
    if(isnumeric(str) == 1) {
        num = strtonum(str);
        return veclen(vec,m) - pow(10,max(0,accuracy)) * num;
    }
    return 0;
}